 
#include "Spline.h"


//------------------------------------------------------------------------------
bool Spline::loadFromFile(const std::string& name, bool loop)
{						
	// set internal parameters
	num_points = 0;
	length = 0.0f;

	// Open file through our vfs 
	FILE* file = fopen(name.c_str(), "rb");	
	if (file == NULL)
		return false;
	
	// Check how much points there are
	vec3 v;
	while(fscanf(file,"%f %f %f",&v.x,&v.y,&v.z) == 3)
        num_points++;

	// Create temporary point array	
	std::vector<vec3> points(num_points);
	num_points = 0;
	
	// Seek file to the beginning
	fseek(file, 0, SEEK_SET);
	
	// Scan all points in
    while(fscanf(file,"%f %f %f",&v.x,&v.y,&v.z) == 3)
        points[num_points++] = v;
	
	// close file, create spline and delete temporary points	
	fclose(file);
	
    // create points
	create(points, loop);	

    return true;
}


//------------------------------------------------------------------------------
void Spline::createFromPoints(const std::vector<vec3>& points, bool loop)
{						
	create(points, loop);
}


//------------------------------------------------------------------------------
void Spline::create(const std::vector<vec3>& points, bool loop)
{
	// allocate memory to hold parameters
	num_points = points.size();
	length = 0.0;
	
    // set new number of parameter points
    params.clear();

    // -------------- IMPLEMENT HERE --------------------------
}

//------------------------------------------------------------------------------
vec3 Spline::operator()(float t)
{
    // no points, hence zero
	if(!num_points) return vec3(0,0,0);

    // -------------- IMPLEMENT HERE --------------------------

    // just return something for now
    return vec3(4.676542, 3.826509, 3.131489);
}


//------------------------------------------------------------------------------
vec3 Spline::operator()(float t,float speed)
{
	return operator()(t * speed / length);
}
