#ifndef __CONSTS_H_INCLUDED__C18A3F59_E674_4d09_8D30_EBF6168C7531
#define __CONSTS_H_INCLUDED__C18A3F59_E674_4d09_8D30_EBF6168C7531

#include "nv_math/nv_algebra.h"
#include "Cg.h"
#include "Spline.h"

//Water & sky

//For easier debugging:
//const float WATER_EXTENT = 1;
//const float WATER_GRID_CELL_SIZE = 0.05;

const float WATER_EXTENT = 10.5;
const float WATER_GRID_CELL_SIZE = 0.5;
const float SKY_DISTANCE = 10.;

//Camera
const float CAMERA_RADIUS = 1.;
const float CAMERA_FOV = 45; //In degrees !!!
const vec3 CAMERA_CENTER_INITAL = vec3(0, 0, 0.9);

//Control variables
extern vec2 gCameraRotation;
extern bool gbDrawDebugCoordSystem;
extern int gCurrentFrameNumber;
extern vec3 gCameraPos;
extern Spline gCameraSpline;
extern vec3 gCameraLookAt;

//Textures
extern GLuint ghEnvMapTexture;

//Cg Programs
//extern CGprogram gWaterVertexProg, gWaterFragmentProg;
//extern CGprogram gSphereFragmentProg, gSphereVertexProg;
extern CgFragmentProgram gWaterFragmentProg, gSphereFragmentProg;
extern CgVertexProgram gWaterVertexProg, gSphereVertexProg;

#endif
